//
//  Character.m
//  RPG-Generator
//
//  Created by Holger Hinzberg on 30.09.09.
//  Copyright 2009 Cocoa-Coding. All rights reserved.
//

#import "Character.h"
#import "Race.h"

@implementation Character

- (NSNumber *)strength {
    return [[strength retain] autorelease];
}

- (void)setStrength:(NSNumber *)value {
    if (strength != value) {
        [strength release];
        strength = [value copy];
    }
}

- (NSNumber *)dexterity {
    return [[dexterity retain] autorelease];
}

- (void)setDexterity:(NSNumber *)value {
    if (dexterity != value) {
        [dexterity release];
        dexterity = [value copy];
    }
}

- (NSNumber *)constitution {
    return [[constitution retain] autorelease];
}

- (void)setConstitution:(NSNumber *)value {
    if (constitution != value) {
        [constitution release];
        constitution = [value copy];
    }
}

- (NSNumber *)intelligence {
    return [[intelligence retain] autorelease];
}

- (void)setIntelligence:(NSNumber *)value {
    if (intelligence != value) {
        [intelligence release];
        intelligence = [value copy];
    }
}

- (NSNumber *)wisdom {
    return [[wisdom retain] autorelease];
}

- (void)setWisdom:(NSNumber *)value {
    if (wisdom != value) {
        [wisdom release];
        wisdom = [value copy];
    }
}

- (NSNumber *)charisma {
    return [[charisma retain] autorelease];
}

- (void)setCharisma:(NSNumber *)value {
    if (charisma != value) {
        [charisma release];
        charisma = [value copy];
    }
}

- (NSString *)characterName {
	return [[characterName retain] autorelease];
}

- (void)setCharacterName:(NSString *)value {
	if (characterName != value) {
		[characterName release];
		characterName = [value copy];
	}
}

- (NSString *)race {
    return [[race retain] autorelease];
}

- (void)setRace:(NSString *)value {
    if (race != value) {
        [race release];
        race = [value copy];
    }
}

- (NSString *)charClass {
    return [[charClass retain] autorelease];
}

- (void)setCharClass:(NSString *)value {
    if (charClass != value) {
        [charClass release];
        charClass = [value copy];
    }
}

- (NSData *)image {
    return [[image retain] autorelease];
}

- (void)setImage:(NSData *)value {
    if (image != value) {
        [image release];
        image = [value copy];
    }
}


- (void) encodeWithCoder:(NSCoder *)aCoder
{
	[aCoder encodeObject:[self strength] forKey:@"strength"];
	[aCoder encodeObject:[self dexterity] forKey:@"dexterity"];
	[aCoder encodeObject:[self constitution] forKey:@"constitution"];
	[aCoder encodeObject:[self intelligence] forKey:@"intelligence"];
	[aCoder encodeObject:[self wisdom] forKey:@"wisdom"];
	[aCoder encodeObject:[self charisma] forKey:@"charisma"];
	[aCoder encodeObject:[self characterName] forKey:@"characterName"];
	[aCoder encodeObject:[self race] forKey:@"race"];
	[aCoder encodeObject:[self charClass] forKey:@"charClass"];
	[aCoder encodeObject:[self image] forKey:@"image"];
}


- (id) initWithCoder:(NSCoder *)aDecoder
{
	if(![super init])
		return nil;
	
	[self setStrength:[aDecoder decodeObjectForKey:@"strength"]];
	[self setDexterity:[aDecoder decodeObjectForKey:@"dexterity"]];
	[self setConstitution:[aDecoder decodeObjectForKey:@"constitution"]];
	[self setIntelligence:[aDecoder decodeObjectForKey:@"intelligence"]];
	[self setWisdom:[aDecoder decodeObjectForKey:@"wisdom"]];
	[self setCharisma:[aDecoder decodeObjectForKey:@"charisma"]];
	[self setCharacterName:[aDecoder decodeObjectForKey:@"characterName"]];
	[self setRace:[aDecoder decodeObjectForKey:@"race"]];
	[self setCharClass:[aDecoder decodeObjectForKey:@"charClass"]];
	[self setImage:[aDecoder decodeObjectForKey:@"image"]];
		
	return self;
}

-(id) copyWithZone:(NSZone *)zone
{
	Character *copyCharacter;
	copyCharacter = [[[self class] allocWithZone:zone] init];	
	
	[copyCharacter setStrength:[self strength]];
	[copyCharacter setDexterity:[self dexterity]];
	[copyCharacter setConstitution:[self constitution]];
	[copyCharacter setIntelligence:[self intelligence]];
	[copyCharacter setWisdom:[self wisdom]];
	[copyCharacter setCharisma:[self charisma]];
	[copyCharacter setCharacterName:[self characterName]];
	[copyCharacter setRace:[self race]];
	[copyCharacter setCharClass:[self charClass]];
	[copyCharacter setImage:[self image]];
		
	return copyCharacter;	
}

@end
